Index: branches/UKMO/dev_r5107_hadgem3_cplfld/NEMOGCM/ARCH/INGV/arch-IBM_EKMAN_INGV.fcm
===================================================================
--- branches/UKMO/dev_r5107_hadgem3_cplfld/NEMOGCM/ARCH/INGV/arch-IBM_EKMAN_INGV.fcm	(revision 5473)
+++ branches/UKMO/dev_r5107_hadgem3_cplfld/NEMOGCM/ARCH/INGV/arch-IBM_EKMAN_INGV.fcm	(revision 5575)
@@ -18,5 +18,5 @@
 %NCDF_INC            -I/srv/lib/netcdf-x/include
 %NCDF_LIB            -L/srv/lib/netcdf-x/lib -lnetcdff -lnetcdf -lhdf5_hl -lhdf5 -lcurl -lstdc++
-%XIOS_ROOT           /home/delrosso/XIOS_482/XIOS
+%XIOS_ROOT           /home/delrosso/XIOS_1.0/xios-1.0
 %MPI_INTEL           -I/srv/intel/impi/4.1.0.024/include
 %CPP                 cpp
Index: branches/UKMO/dev_r5107_hadgem3_cplfld/NEMOGCM/ARCH/OLD/arch-ifort_MERCATOR_CLUSTER.fcm
===================================================================
--- branches/UKMO/dev_r5107_hadgem3_cplfld/NEMOGCM/ARCH/OLD/arch-ifort_MERCATOR_CLUSTER.fcm	(revision 5473)
+++ branches/UKMO/dev_r5107_hadgem3_cplfld/NEMOGCM/ARCH/OLD/arch-ifort_MERCATOR_CLUSTER.fcm	(revision 5575)
@@ -16,14 +16,17 @@
 
 %NCDF_INC            -I$NETCDF_INC
-%NCDF_LIB            -L $NETCDF_LIB -lnetcdf
+%NCDF_LIB            -L$NETCDF_LIB -lnetcdff -lnetcdf -L$HDF5_LIB -lhdf5_hl -lhdf5 -lz
+
+%CPP                 cpp
 %FC                  mpif90
-%FCFLAGS             -assume byterecl -convert big_endian -i4 -r8 -O2 -fp-model precise
+%FCFLAGS             -O2 -fp-model precise  -traceback -r8  -convert big_endian -assume byterecl
 %FFLAGS              %FCFLAGS
-%LD                  mpif90
+%LD                   mpif90
 %FPPFLAGS            -P -C -traditional
-%LDFLAGS             -O2 -shared-intel 
+%LDFLAGS             -O2
 %AR                  ar
-%ARFLAGS             -r
+%ARFLAGS             -rs
 %MK                  gmake
-%USER_INC            %NCDF_INC
-%USER_LIB            %NCDF_LIB
+%USER_INC            -I$XIOS_INC %NCDF_INC
+%USER_LIB            -L$XIOS_LIB -lxios %NCDF_LIB -lstdc++
+
Index: branches/UKMO/dev_r5107_hadgem3_cplfld/NEMOGCM/ARCH/arch-PW7_METO.fcm
===================================================================
--- branches/UKMO/dev_r5107_hadgem3_cplfld/NEMOGCM/ARCH/arch-PW7_METO.fcm	(revision 5473)
+++ branches/UKMO/dev_r5107_hadgem3_cplfld/NEMOGCM/ARCH/arch-PW7_METO.fcm	(revision 5575)
@@ -17,8 +17,8 @@
 
 
-%NCDF_INC            -I/home/cr/ocean/hadcv/netcdf/4.1.3_seq/include
-%NCDF_LIB            -L/home/cr/ocean/hadcv/netcdf/4.1.3_seq/lib -lnetcdf -lnetcdff -lhdf5 -lhdf5_hl -lhdf5_fortran -lz
-%XIOS_INC            -I/home/cr/ocean/hadcv/xios_lib/par/r521/xios/inc
-%XIOS_LIB            -L/home/cr/ocean/hadcv/xios_lib/par/r521/xios/lib -lxios
+%NCDF_INC            -I/home/cr/ocean/hadcv/netcdf/4.1.3_par/include
+%NCDF_LIB            -L/home/cr/ocean/hadcv/netcdf/4.1.3_par/lib -lnetcdf -lnetcdff -lhdf5 -lhdf5_hl -lhdf5_fortran -lz
+%XIOS_INC            -I/home/cr/ocean/hadcv/xios_lib/par/r618/xios/inc
+%XIOS_LIB            -L/home/cr/ocean/hadcv/xios_lib/par/r618/xios/lib -lxios
 %CPP	             cpp
 %FC                  mpxlf90_r
Index: branches/UKMO/dev_r5107_hadgem3_cplfld/NEMOGCM/ARCH/arch-X64_ADA.fcm
===================================================================
--- branches/UKMO/dev_r5107_hadgem3_cplfld/NEMOGCM/ARCH/arch-X64_ADA.fcm	(revision 5473)
+++ branches/UKMO/dev_r5107_hadgem3_cplfld/NEMOGCM/ARCH/arch-X64_ADA.fcm	(revision 5575)
@@ -32,5 +32,6 @@
 %HDF5_HOME           /smplocal/pub/HDF5/1.8.9/par
 %XIOS_HOME           $WORKDIR/XIOS
-%OASIS_HOME          /not/yet/defined
+####%OASIS_HOME          $WORKDIR/oasis3-mct/BLD
+%OASIS_HOME          /not/defined
 
 %NCDF_INC            -I%NCDF_HOME/include 
Index: branches/UKMO/dev_r5107_hadgem3_cplfld/NEMOGCM/ARCH/arch-X64_CURIE.fcm
===================================================================
--- branches/UKMO/dev_r5107_hadgem3_cplfld/NEMOGCM/ARCH/arch-X64_CURIE.fcm	(revision 5473)
+++ branches/UKMO/dev_r5107_hadgem3_cplfld/NEMOGCM/ARCH/arch-X64_CURIE.fcm	(revision 5575)
@@ -29,7 +29,7 @@
 #  - fcm variables are starting with a % (and not a $)
 #
-%NCDF_HOME           /usr/local/netcdf-4.2_hdf5_parallel
-%HDF5_HOME           /usr/local/hdf5-1.8.9_parallel
-%XIOS_HOME           $WORKDIR/now/models/xios
+%NCDF_HOME            /usr/local/netcdf-4.3.3.1_hdf5_parallel
+%HDF5_HOME           /usr/local/hdf5-1.8.12_parallel
+%XIOS_HOME           $WORKDIR/xios-1.0
 %OASIS_HOME          $WORKDIR/now/models/oa3mct
 
Index: branches/UKMO/dev_r5107_hadgem3_cplfld/NEMOGCM/ARCH/arch-X64_MOBILIS.fcm
===================================================================
--- branches/UKMO/dev_r5107_hadgem3_cplfld/NEMOGCM/ARCH/arch-X64_MOBILIS.fcm	(revision 5473)
+++ branches/UKMO/dev_r5107_hadgem3_cplfld/NEMOGCM/ARCH/arch-X64_MOBILIS.fcm	(revision 5575)
@@ -36,5 +36,5 @@
 %NCDF_HOME           /home/acc/shared
 %HDF5_HOME           /home/acc/shared
-%XIOS_HOME           /home/acc/XIOS
+%XIOS_HOME           /home/acc/XIOS_1.0
 %OASIS_HOME          
 
Index: branches/UKMO/dev_r5107_hadgem3_cplfld/NEMOGCM/ARCH/arch-XC40_METO.fcm
===================================================================
--- branches/UKMO/dev_r5107_hadgem3_cplfld/NEMOGCM/ARCH/arch-XC40_METO.fcm	(revision 5575)
+++ branches/UKMO/dev_r5107_hadgem3_cplfld/NEMOGCM/ARCH/arch-XC40_METO.fcm	(revision 5575)
@@ -0,0 +1,52 @@
+# compiler options for Archer CRAY XC-40 (using crayftn compiler)
+#
+# NCDF_HOME   root directory containing lib and include subdirectories for netcdf4
+# HDF5_HOME   root directory containing lib and include subdirectories for HDF5
+# XIOS_HOME   root directory containing lib for XIOS
+# OASIS_HOME  root directory containing lib for OASIS
+#
+# NCDF_INC    netcdf4 include file
+# NCDF_LIB    netcdf4 library
+# XIOS_INC    xios include file    (taken into accound only if key_iomput is activated)
+# XIOS_LIB    xios library         (taken into accound only if key_iomput is activated)
+# OASIS_INC   oasis include file   (taken into accound only if key_oasis3 is activated)
+# OASIS_LIB   oasis library        (taken into accound only if key_oasis3 is activated)
+#
+# FC          Fortran compiler command
+# FCFLAGS     Fortran compiler flags
+# FFLAGS      Fortran 77 compiler flags
+# LD          linker
+# LDFLAGS     linker flags, e.g. -L<lib dir> if you have libraries
+# FPPFLAGS    pre-processing flags
+# AR          assembler
+# ARFLAGS     assembler flags
+# MK          make
+# USER_INC    complete list of include files
+# USER_LIB    complete list of libraries to pass to the linker
+#
+# Note that:
+#  - unix variables "$..." are accpeted and will be evaluated before calling fcm.
+#  - fcm variables are starting with a % (and not a $)
+#
+%NCDF_HOME           /opt/cray/netcdf-hdf5parallel/4.3.2/CRAY/83
+%HDF5_HOME           /opt/cray/hdf5-parallel/1.8.13/CRAY/83
+%XIOS_HOME           /projects/ocean/nemo/xios/xios_1.0_r618_20150619/XIOS
+
+%NCDF_INC            -I%NCDF_HOME/include -I%HDF5_HOME/include
+%NCDF_LIB            -L%HDF5_HOME/lib -L%NCDF_HOME/lib -lnetcdff -lnetcdf -lhdf5_hl -lhdf5 -lz
+%XIOS_INC            -I%XIOS_HOME/inc 
+%XIOS_LIB            -L%XIOS_HOME/lib -lxios
+
+%CPP                 cpp
+%FC                  ftn
+%FCFLAGS             -emf -s real64 -s integer32  -O2 -hflex_mp=intolerant -Rb
+%FFLAGS              -emf -s real64 -s integer32  -O0 -hflex_mp=strict -Rb
+%LD                  ftn
+%FPPFLAGS            -P -E -traditional-cpp
+%LDFLAGS             -hbyteswapio 
+%AR                  ar 
+%ARFLAGS             -r
+%MK                  gmake
+
+%USER_INC            %XIOS_INC
+%USER_LIB            %XIOS_LIB
Index: branches/UKMO/dev_r5107_hadgem3_cplfld/NEMOGCM/ARCH/arch-macport_osx.fcm
===================================================================
--- branches/UKMO/dev_r5107_hadgem3_cplfld/NEMOGCM/ARCH/arch-macport_osx.fcm	(revision 5473)
+++ branches/UKMO/dev_r5107_hadgem3_cplfld/NEMOGCM/ARCH/arch-macport_osx.fcm	(revision 5575)
@@ -40,5 +40,5 @@
 %NCDF_HOME           /opt/local
 %HDF5_HOME           /opt/local
-%XIOS_HOME           /Users/$( whoami )/XIOS
+%XIOS_HOME           /Users/$( whoami )/xios-1.0
 %OASIS_HOME          /not/defined
 